//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2008, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 5
//----
#property indicator_color1 Lime
#property indicator_color2 Aqua
#property indicator_color3 Red
#property indicator_color4 DarkTurquoise
#property indicator_color5 Red
#property indicator_level1 70
#property indicator_level2 50
#property indicator_level3 30
#property indicator_levelcolor Gray
#property indicator_levelwidth 1
#property indicator_levelstyle STYLE_DASH

extern string TimeFrame = "Current time frame";
extern int    Rsi       = 14;
extern int    Ma        = 8;

//----
double RsiBuf[];
double MaP[];
double MaF[];
double Up[];
double Dn[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle (0, DRAW_LINE,0,2);
   SetIndexStyle (1, DRAW_LINE,0,2);
   SetIndexStyle (2, DRAW_LINE,0,2);
   SetIndexStyle (3, DRAW_ARROW);
   SetIndexStyle (4, DRAW_ARROW);
   SetIndexBuffer(0, RsiBuf);
   SetIndexBuffer(1, MaP);
   SetIndexBuffer(2, MaF);
   SetIndexBuffer(3, Up);
   SetIndexBuffer(4, Dn);
   SetIndexArrow(3,108);
   SetIndexArrow(4,108);
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
  IndicatorShortName(timeFrameToString(timeFrame)+ " SGMAR");
return (0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  void deinit() 
  {}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { RsiBuf[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--) RsiBuf[i] = iRSI(NULL,0,Rsi,PRICE_CLOSE,i);
      for(i=limit; i>=0; i--)
      {
         MaF[i] = iMAOnArray(RsiBuf,0,Ma,0,MODE_SMA,i);
         MaP[i] = iMAOnArray(RsiBuf,0,Ma,0,MODE_EMA,i);
         Up[i] = EMPTY_VALUE;
         Dn[i] = EMPTY_VALUE;
         if((MaF[i]-MaP[i])*(MaF[i+1]-MaP[i+1])<0)
         {
           if(MaF[i]-MaP[i]<0) Up[i]=MaP[i];
           else                Dn[i]=MaF[i];
         }
      }
     
     //
     //
     //
     //
     //
     
      return (0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         RsiBuf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rsi,Ma,0,y);
         MaF[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rsi,Ma,1,y);
         MaP[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rsi,Ma,2,y);
         Up[i] = EMPTY_VALUE;
         Dn[i] = EMPTY_VALUE;
         if((MaF[i]-MaP[i])*(MaF[i+1]-MaP[i+1])<0)
         {
           if(MaF[i]-MaP[i]<0) Up[i]=MaP[i];
           else                Dn[i]=MaF[i];
         }
         
   } 
   return(0);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

